"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function headerTemplate(type, scope, subject) {
    var header = "" + type;
    if (scope) {
        header += "(" + scope + ")";
    }
    header += ': ';
    if (subject) {
        header += subject;
    }
    return header;
}
exports.headerTemplate = headerTemplate;
function renderSection(value) {
    return value ? "\n" + value : '';
}
function commitTemplate(answers) {
    var _a;
    var template = headerTemplate(answers.type, answers.scope, answers.subject);
    template += renderSection(answers.body);
    template += renderSection(answers.breaking);
    if (answers.breaking) {
        template += (_a = answers.issue, (_a !== null && _a !== void 0 ? _a : ''));
    }
    else {
        template += renderSection(answers.issue);
    }
    return template;
}
exports.commitTemplate = commitTemplate;
