"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function enumWhen(rule) {
    if (rule == null) {
        return true;
    }
    var level = rule[0], applicable = rule[1], value = rule[2];
    if (level == 0 /* Disable */) {
        return true;
    }
    var emptyEnum = value.length == 0;
    if (applicable == 'always') {
        return !emptyEnum;
    }
    return true;
}
exports.enumWhen = enumWhen;
function emptyWhen(rule) {
    if (rule == null) {
        return true;
    }
    var level = rule[0], applicable = rule[1];
    if (level == 0 /* Disable */) {
        return true;
    }
    return applicable == 'never';
}
exports.emptyWhen = emptyWhen;
function whenFactory(enumRule, emptyRule) {
    return function () {
        // return false if either of the rules return false
        return ![enumWhen(enumRule), emptyWhen(emptyRule)].includes(false);
    };
}
exports.whenFactory = whenFactory;
